

!!! Listing 1

prompt> echo $CLASSPATH
.:$JHOME/jini1_0/lib/jini-core.jar:$JHOME/jini1_0/lib/sun-util.jar:$JHOME/jini1_0/lib/reggie.jar:$JHOME/jini1_0/lib/reggie_dl.jar:$JHOME/jini1_0/lib/jini-ext.jar

prompt> java -jar -Djava.security.policy=$JHOME/jini1_0/example/lookup/policy.all
$JHOME/jini1_0/lib/reggie.jar http://<hostname>:8080/reggie_dl.jar
$JHOME/jini1_0/example/lookup/policy.all /tmp/reggie_log public

!!! Listing 2

prompt> java -cp $JHOME/jini1_0/lib/jini-examples.jar
-Djava.security.policy=$JHOME/jini1_0/example/browser/policy -Djava.rmi.server.codebase=http://
<hostname>:8080/jini-examples-dl.jar com.sun.jini.example.browser.Browser -admin &


!!! Listing 3

import java.rmi.*;

public interface JiniAddServiceInterface extends Remote {
    public int add(int a, int b) throws RemoteException;
}

!!! Listing 4

import java.rmi.*;
import java.rmi.server.*;

public class AddInterface_impl extends UnicastRemoteObject
        implements AddInterface {

    public AddInterface_impl() throws RemoteException {
        super();
    }
    
    public int add (int a, int b) throws RemoteException {
        System.out.println ("server: " + a + "+" 
                            + b + "= " + (a+b) );
        return (a+b);
    }
}

!!! Listing 5

import java.rmi.RMISecurityManager;

[...]
import net.jini.core.lookup.*; 
import com.sun.jini.lookup.*; 
import com.sun.jini.lease.LeaseRenewalManager; 

public class JiniAddService implements ServiceIDListener {
    
    public void serviceIDNotify (ServiceID idIn) {
    }
    
    public static void main(String[] args) throws Exception {
        System.setSecurityManager(new RMISecurityManager());
            
    AddInterface_impl adder = new AddInterface_impl();
        
    JoinManager joinManager = new JoinManager(
adder, // anzumeldendes Service Objekt
                                        null, // Attribute des Service
                (ServiceIDListener) new JiniAddService(),
new LeaseRenewalManager()); //Leases erneuern
                        
    System.out.println("JiniAddService bound in LUS");
        
         Thread.currentThread().sleep(100000);
    }    
}

!!! Listing 6

import net.jini.discovery.LookupLocator;
import net.jini.lookup.*;
import java.rmi.RMISecurityManager;

class JiniAddClient {

    public static void main(String args[]) throws Exception {
        System.setSecurityManager(new RMISecurityManager());

        LookupLocator locator=new LookupLocator("jini://localhost"); 

        ServiceRegistrar sr=locator.getRegistrar();
                
        Class[] classes=new Class[] { AddInterface.class };
        ServiceTemplate st=new ServiceTemplate(
null, // ID
                                classes, // types 
null);   // attributes
                
        AddInterface service=(AddInterface)sr.lookup(st);
                        
        int result=service.add(3,5);
    }
}

!!! Listing 7

import java.rmi.*;
import net.jini.core.lookup.*;
import net.jini.discovery.*;

public class JiniAddClient implements DiscoveryListener {

    private static LookupDiscovery ldisc;        
    private static JiniAddClient jc;
    private static ServiceRegistrar[] registrars;
    
    public static void main(String args[]) throws Exception {
         System.setSecurityManager(new RMISecurityManager());
    
        ldisc = new LookupDiscovery(LookupDiscovery.ALL_GROUPS);
         jc=new JiniAddClient();
         ldisc.addDiscoveryListener(jc);
                
         Class[] cl = new Class[] {AddInterface.class};
         ServiceTemplate template = new ServiceTemplate(null, cl, null); 
                        
         boolean found=false;                   
         while(!found) {
             ServiceRegistrar[] regs;
             synchronized(jc) {
                 jc.wait();
                  regs=registrars;
             }
             for(int i=0; i<regs.length; i++) {
                 Object o=regs[i].lookup(template);
                  if(o == null)
                      continue;
                  found=true;
                  System.out.println("3 + 5 = "+ ((AddInterface)o).add(3,5));
                  break;
             }                  
         }
                
         ldisc.terminate();
    }

    public void discovered(DiscoveryEvent discEv) {
        synchronized(jc) {
             registrars=discEv.getRegistrars();
             jc.notify();
        }
    }
        
    public void discarded(DiscoveryEvent e) {
    } 
}

!!! Listing 8

public class ServiceInfo extends AbstractEntry 
    implements ServiceControlled {
                [...]
    public ServiceInfo(String name, String manufacturer, String vendor,
                       String version, String model, String serialNumber) {
        [...]
    }

    public String name;
    public String manufacturer;
    public String vendor;
    public String version;
    public String model;
    public String serialNumber;
}

!!! Listing 9

Entry[] attributes = new Entry[] 
{ new Name("JiniAddService"), 
  new ServiceInfo("Jini Enabled Adder Service", 
                  "az", "az", "1.0beta", "", "08/15") };



!!! Listing 10

Entry[] info = new Entry[] 
{ new ServiceInfo(null,null,null,"1.0beta",null,null) };
ServiceTemplate template = new ServiceTemplate(null, cl, info); 
